Package org.apache.groovy.contracts.ast

# Class MethodVariantInheritanceASTTransformation

java.lang.Object
org.apache.groovy.contracts.ast.MethodVariantInheritanceASTTransformation

All Implemented Interfaces:
  `ASTTransformation`

public class MethodVariantInheritanceASTTransformation extends Object implements ASTTransformation
Inherits a method-level `Decreases` termination measure onto an override that does not redeclare it — mirroring how groovy-contracts inherits `@Requires`/`@Ensures` (Liskov substitution). Because such an override carries no annotation of its own, the per-annotation `MethodVariantASTTransformation` never fires on it; this global transform fills that gap.

For each concrete method that overrides a super-type method carrying `@Decreases` (and does not declare its own), the ancestor's measure — re-mapped from the ancestor's parameter names to the override's, since an override may rename parameters — is woven onto the override via `MethodVariantASTTransformation.weaveMeasure(org.codehaus.groovy.ast.MethodNode, org.codehaus.groovy.ast.expr.Expression, org.codehaus.groovy.control.SourceUnit)`. An override is free to declare its own `@Decreases` to refine the measure; in that case the local transform handles it and this one skips it.

Limitation: the ancestor's measure must be available as source AST (same compilation unit). When the ancestor is a precompiled (binary) super-type, its measure closure survives only as a generated class, so the override degrades to no recursion check — sound (conservative), and a documented follow-up.

Since:
  6.0.0
See Also:
  - `Decreases`
  - `MethodVariantASTTransformation`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MethodVariantInheritanceASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MethodVariantInheritanceASTTransformation

    public MethodVariantInheritanceASTTransformation()

- ## Method Details

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.